/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;
import org.threeten.bp.LocalDate;

import java.util.Objects;

/**
 * Insurance
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Insurance {
  @SerializedName("is_internal")
  private Boolean isInternal = null;

  @SerializedName("amount")
  private Model63 amount = null;

  @SerializedName("date")
  private LocalDate date = null;

  @SerializedName("description")
  private String description = null;

  public Insurance isInternal(Boolean isInternal) {
    this.isInternal = isInternal;
    return this;
  }

   /**
   * Is the other insurance internal or external. The insurance that covers this incident can be from the same company than the one used for this claim (internal) or from another insurance company (external).
   * @return isInternal
  **/
  @ApiModelProperty(value = "Is the other insurance internal or external. The insurance that covers this incident can be from the same company than the one used for this claim (internal) or from another insurance company (external).")
  public Boolean isIsInternal() {
    return isInternal;
  }

  public void setIsInternal(Boolean isInternal) {
    this.isInternal = isInternal;
  }

  public Insurance amount(Model63 amount) {
    this.amount = amount;
    return this;
  }

   /**
   * Get amount
   * @return amount
  **/
  @ApiModelProperty(value = "")
  public Model63 getAmount() {
    return amount;
  }

  public void setAmount(Model63 amount) {
    this.amount = amount;
  }

  public Insurance date(LocalDate date) {
    this.date = date;
    return this;
  }

   /**
   * Starting date of the other insurance. ISO 8601 format (YYYY-MM-DD)
   * @return date
  **/
  @ApiModelProperty(value = "Starting date of the other insurance. ISO 8601 format (YYYY-MM-DD)")
  public LocalDate getDate() {
    return date;
  }

  public void setDate(LocalDate date) {
    this.date = date;
  }

  public Insurance description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Description of the insurance.
   * @return description
  **/
  @ApiModelProperty(value = "Description of the insurance.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Insurance insurance = (Insurance) o;
    return Objects.equals(this.isInternal, insurance.isInternal) &&
        Objects.equals(this.amount, insurance.amount) &&
        Objects.equals(this.date, insurance.date) &&
        Objects.equals(this.description, insurance.description);
  }

  @Override
  public int hashCode() {
    return Objects.hash(isInternal, amount, date, description);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Insurance {\n");
    
    sb.append("    isInternal: ").append(toIndentedString(isInternal)).append("\n");
    sb.append("    amount: ").append(toIndentedString(amount)).append("\n");
    sb.append("    date: ").append(toIndentedString(date)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

